Are random seeds "spent" in some way? - r
I expected this code to give me the same number each time:
set.seed(1)
sample(rep(1:100), size = 1)
However, it doesn't. Here's is how it behaves: it gives me the same number if I run the two lines directly after each other, however, if I then run the second line once again, it gives me something different. Does that mean the seed is "spent" after running sample() once?
I need to produce code that includes random sampling, but which is reproducible. How can I make sure the same, random number is produced each time?
This isn't exactly how things really work, but it helps for understanding.
Imagine that we're drawing numbers between 0 and 9 by looking them up in a pre-generated book of random numbers. A really long book with lots and lots of random draws made by some bored undergraduate intern with a fair 10-sided die. What R normally does is look at the number following whatever the previous random number was in the book. So if the book starts 4, 5, 2, 8, 3, 4, 4, 1, 7, 0, 4, ... the first random number will be 4, then 5 etc.
The results will be as random as the book is---no matter where in the book we start. Typically, you don't know what you're going to get because you have no idea where in the book R is currently at, maybe page 103, maybe page 10003. Setting the seed tells R to start at a specific place. So set.seed(1) says "start on page 1", so you now can count on that "4" being first, and then followed by a 5, and so forth.
It's not that the seed is spent; rather, setting the seed produces a fixed sequence of pseudo-random values that you'll be sampling from. Once you've sampled one value from the sequence, the next value you sample will be the subsequent value in the sequence. However, if you reset the seed, then you will start back at the beginning of the sequence when you sample again.
Related
Making a for loop in r
I am just getting started with R so I am sorry if I say things that dont make sense. I am trying to make a for loop which does the following, l_dtest[[1]]<-vector() l_dtest[[2]]<-vector() l_dtest[[3]]<-vector() l_dtest[[4]]<-vector() l_dtest[[5]]<-vector() all the way up till any number which will be assigned as n. for example, if n was chosen to be 100 then it would repeat this all the way to > l_dtest[[100]]<-vector(). I have tried multiple different attempts at doing this and here is one of them. n<-4 p<-(1:n) l_dtest<-list() for(i in p){ print((l_dtest[i]<-vector())<-i) } Again I am VERY new to R so I don't know what I am doing or what is wrong with this loop. The detailed background for why I need to do this is that I need to write an R function that receives as input the size of the population "n", runs a simulation of the model below with that population size, and returns the number of generations it took to reach a MRCA (most recent common ancestor). Here is the model, We assume the population size is constant at n. Generations are discrete and non-overlapping. The genealogy is formed by this random process: in each generation, each individual chooses two parents at random from the previous generation. The choices are made randomly and equally likely over the n possibilities and each individual chooses twice. All choices are made independently. Thus, for example, it is possible that, when an individual chooses his two parents, he chooses the same individual twice, so that in fact he ends up with just one parent; this happens with probability 1/n. I don't understand the specific step at the begining of this post or why I need to do it but my teacher said I do. I don't know if this helps but the next step is choosing parents for the first person and then combining the lists from the step I posted with a previous step. It looks like this, sample(1:5, 2, replace=T) #[1] 1 2 l_dtemp[[1]]<-union(l_dtemp[[1]], l_d[[1]]) #To my understanding, l_dtem[[1]] is now receiving the listdescandants from l_d[[1]] bcs the ladder chose l_dtemp[[1]] as first parent l_dtemp[[2]]<-union(l_dtemp[[2]], l_d[[1]]) #Same as ^^ but for l_d[[1]]'s 2nd choice which is l_dtemp[[2]] sample(1:5, 2, replace=T) #[1] 1 3 l_dtemp[[1]]<-union(l_dtemp[[1]], l_d[[2]]) l_dtemp[[3]]<-union(l_dtemp[[3]], l_d[[2]])
Optimizing (minimizing) the number of lines in file: an optimization problem in line with permutations and agenda scheduling
I have a calendar, typically a csv file containing a number of lines. Each line corresponds to an individual and is a sequence of consecutive values '0' and '1' where '0' refers to an empty time slot and '1' to an occupied slot. There cannot be two separated sequences in a line (e.g. two sequences of '1' separated by a '0' such as '1,1,1,0,1,1,1,1'). The problem is to minimize the number of lines by combining the individuals and resolving the collisions between time slots. Note the time slots cannot overlap. For example, for 4 individuals, we have the following sequences: id1:1,1,1,0,0,0,0,0,0,0 id2:0,0,0,0,0,0,1,1,1,1 id3:0,0,0,0,1,0,0,0,0,0 id4:1,1,1,1,0,0,0,0,0,0 One can arrange them to end up with two lines, while keeping track of permuted individuals (for the record). In our example it yields: 1,1,1,0,1,0,1,1,1,1 (id1 + id2 + id3) 1,1,1,1,0,0,0,0,0,0 (id4) The constraints are the following: The number of individuals range from 500 to 1000, The length of the sequence will never exceed 30 Each sequence in the file has the exact same length, The algorithm needs to be reasonable in execution time because this task may be repeated up to 200 times. We don't necessarly search for the optimal solution, a near optimal solution would suffice. We need to keep track of the combined individuals (as in the example above) Genetic algorithms seems a good option but how does it scales (in terms of execution time) with the size of this problem? A suggestion in Matlab or R would be (greatly) appreciated. Here is a sample test: id1:1,1,1,0,0,0,0,0,0,0 id2:0,0,0,0,0,0,1,1,1,1 id3:0,0,0,0,1,0,0,0,0,0 id4:1,1,1,1,1,0,0,0,0,0 id5:0,1,1,1,0,0,0,0,0,0 id6:0,0,0,0,0,0,0,1,1,1 id7:0,0,0,0,1,1,1,0,0,0 id8:1,1,1,1,0,0,0,0,0,0 id9:1,1,0,0,0,0,0,0,0,0 id10:0,0,0,0,0,0,1,1,0,0 id11:0,0,0,0,1,0,0,0,0,0 id12:0,1,1,1,0,0,0,0,0,0 id13:0,0,0,1,1,1,0,0,0,0 id14:0,0,0,0,0,0,0,0,0,1 id15:0,0,0,0,1,1,1,1,1,1 id16:1,1,1,1,1,1,1,1,0,0 Solution(s) #Nuclearman provided a working solution in O(NT) (where N is the number of individuals (ids) and T is the number of time slots (columns)) based on the Greedy algorithm.
I study algorithms as a hobby and I agree with Caduchon on this one, that greedy is the way to go. Though I believe this is actually the clique cover problem, to be more accurate: https://en.wikipedia.org/wiki/Clique_cover Some ideas on how to approach building cliques can be found here: https://en.wikipedia.org/wiki/Clique_problem Clique problems are related to independence set problems. Considering the constraints, and that I'm not familiar with matlab or R, I'd suggest this: Step 1. Build the independence set time slot data. For each time slot that is a 1, create a mapping (for fast lookup) of all records that also have a one. None of these can be merged into the same row (they all need to be merged into different rows). IE: For the first column (slot), the subset of the data looks like this: id1 :1,1,1,0,0,0,0,0,0,0 id4 :1,1,1,1,1,0,0,0,0,0 id8 :1,1,1,1,0,0,0,0,0,0 id9 :1,1,0,0,0,0,0,0,0,0 id16:1,1,1,1,1,1,1,1,0,0 The data would be stored as something like 0: Set(id1,id4,id8,id9,id16) (zero indexed rows, we start at row 0 instead of row 1 though probably doesn't matter here). Idea here is to have O(1) lookup. You may need to quickly tell that id2 is not in that set. You can also use nested hash tables for that. IE: 0: { id1: true, id2: true }`. Sets also allow for usage of set operations which may help quite a bit when determining unassigned columns/ids. In any case, none of these 5 can be grouped together. That means at best (given that row) you must have at least 5 rows (if the other rows can be merged into those 5 without conflict). Performance of this step is O(NT), where N is the number of individuals and T is the number of time slots. Step 2. Now we have options of how to attack things. To start, we pick the time slot with the most individuals and use that as our starting point. That gives us the min possible number of rows. In this case, we actually have a tie, where the 2nd and 5th rows both have 7. I'm going with the 2nd, which looks like: id1 :1,1,1,0,0,0,0,0,0,0 id4 :1,1,1,1,1,0,0,0,0,0 id5 :0,1,1,1,0,0,0,0,0,0 id8 :1,1,1,1,0,0,0,0,0,0 id9 :1,1,0,0,0,0,0,0,0,0 id12:0,1,1,1,0,0,0,0,0,0 id16:1,1,1,1,1,1,1,1,0,0 Step 3. Now that we have our starting groups we need to add to them while trying to avoid conflicts between new members and old group members (which would require an additional row). This is where we get into NP-complete territory as there are a ton (roughly 2^N to be more accurately) to assign things. I think the best approach might be a random approach as you can theoretically run it as many times as you have time for to get results. So here is the randomized algorithm: Given the starting column and ids (1,4,5,8,9,12,16 above). Mark this column and ids as assigned. Randomly pick an unassigned column (time slot). If you want a perhaps "better" result. Pick the one with the least (or most) number of unassigned ids. For faster implementation, just loop over the columns. Randomly pick an unassigned id. For a better result, perhaps the one with the most/least groups that could be assigned that ID. For faster implementation, just pick the first unassigned id. Find all groups that unassigned ID could be assigned to without creating conflict. Randomly assign it to one of them. For faster implementation, just pick the first one that doesn't cause a conflict. If there are no groups without conflict, create a new group and assign the id to that group as the first id. The optimal result is that no new groups have to be created. Update the data for that row (make 0s into 1s as needed). Repeat steps 3-5 until no unassigned ids for that column remain. Repeat steps 2-6 until no unassigned columns remain. Example with the faster implementation approach, which is an optimal result (there cannot be less than 7 rows and there are only 7 rows in the result). First 3 columns: No unassigned ids (all have 0). Skipped. 4th Column: Assigned id13 to id9 group (13=>9). id9 Looks like this now, showing that the group that started with id9 now also includes id13: id9 :1,1,0,1,1,1,0,0,0,0 (+id13) 5th Column: 3=>1, 7=>5, 11=>8, 15=>12 Now it looks like: id1 :1,1,1,0,1,0,0,0,0,0 (+id3) id4 :1,1,1,1,1,0,0,0,0,0 id5 :0,1,1,1,1,1,1,0,0,0 (+id7) id8 :1,1,1,1,1,0,0,0,0,0 (+id11) id9 :1,1,0,1,1,1,0,0,0,0 (+id13) id12:0,1,1,1,1,1,1,1,1,1 (+id15) id16:1,1,1,1,1,1,1,1,0,0 We'll just quickly look the next columns and see the final result: 7th Column: 2=>1, 10=>4 8th column: 6=>5 Last column: 14=>4 So the final result is: id1 :1,1,1,0,1,0,1,1,1,1 (+id3,id2) id4 :1,1,1,1,1,0,1,1,0,1 (+id10,id14) id5 :0,1,1,1,1,1,1,1,1,1 (+id7,id6) id8 :1,1,1,1,1,0,0,0,0,0 (+id11) id9 :1,1,0,1,1,1,0,0,0,0 (+id13) id12:0,1,1,1,1,1,1,1,1,1 (+id15) id16:1,1,1,1,1,1,1,1,0,0 Conveniently, even this "simple" approach allowed for us to assign the remaining ids to the original 7 groups without conflict. This is unlikely to happen in practice with as you say "500-1000" ids and up to 30 columns, but far from impossible. Roughly speaking 500 / 30 is roughly 17, and 1000 / 30 is roughly 34. So I would expect you to be able to get down to roughly 10-60 rows with about 15-45 being likely, but it's highly dependent on the data and a bit of luck. In theory, the performance of this method is O(NT) where N is the number of individuals (ids) and T is the number of time slots (columns). It takes O(NT) to build the data structure (basically converting the table into a graph). After that for each column it requires checking and assigning at most O(N) individual ids, they might be checked multiple times. In practice since O(T) is roughly O(sqrt(N)) and performance increases as you go through the algorithm (similar to quick sort), it is likely O(N log N) or O(N sqrt(N)) on average, though really it's probably more accurate to use O(E) where E is the number of 1s (edges) in the table. Each each likely gets checked and iterated over a fixed number of times. So that is probably a better indicator. The NP hard part comes into play in working out which ids to assign to which groups such that no new groups (rows) are created or a lowest possible number of new groups are created. I would run the "fast implementation" and the "random" approaches a few times and see how many extra rows (beyond the known minimum) you have, if it's a small amount.
This problem, contrary to some comments, is not NP-complete due to the restriction that "There cannot be two separated sequences in a line". This restriction implies that each line can be considered to be representing a single interval. In this case, the problem reduces to a minimum coloring of an interval graph, which is known to be optimally solved via a greedy approach. Namely, sort the intervals in descending order according to their ending times, then process the intervals one at a time in that order always assigning each interval to the first color (i.e.: consolidated line) that it doesn't conflict with or assigning it to a new color if it conflicts with all previously assigned colors.
Consider a constraint programming approach. Here is a question very similar to yours: Constraint Programming: Scheduling with multiple workers. A very simple MiniZinc-model could also look like (sorry no Matlab or R): include "globals.mzn"; %int: jobs = 4; int: jobs = 16; set of int: JOB = 1..jobs; %array[JOB] of var int: start = [0, 6, 4, 0]; %array[JOB] of var int: duration = [3, 4, 1, 4]; array[JOB] of var int: start = [0, 6, 4, 0, 1, 8, 4, 0, 0, 6, 4, 1, 3, 9, 4, 1]; array[JOB] of var int: duration = [3, 4, 1, 5, 3, 2, 3, 4, 2, 2, 1, 3, 3, 1, 6, 8]; var int: machines; constraint cumulative(start, duration, [1 | j in JOB], machines); solve minimize machines; This model does not, however, tell which jobs are scheduled on which machines. Edit: Another option would be to transform the problem into a graph coloring problem. Let each line be a vertex in a graph. Create edges for all overlapping lines (the 1-segments overlap). Find the chromatic number of the graph. The vertices of each color then represent a combined line in the original problem. Graph coloring is a well-studied problem, for larger instances consider a local search approach, using tabu search or simulated annealing.
Generate permutations in sequential order - R
I previously asked the following question Permutation of n bernoulli random variables in R The answer to this question works great, as long as n is relatively small (<30), otherwise the following error code occurs Error: cannot allocate vector of size 4.0 Gb. I can get the code to run with somewhat larger values by using my desktop at work but eventually the same error occurs. Even for values that my computer can handle, say 25, the code is extremely slow. The purpose of this code to is to calculate the difference between the CDF of an exact distribution (hence the permutations) and a normal approximation. I randomly generate some data, calculate the test statistic and then I need to determine the CDF by summing all the permutations that result in a smaller test statistic value divided by the total number of permutations. My thought is to just generate the list of permutations one at a time, note if it is smaller than my observed value and then go on to the next one, i.e. loop over all possible permutations, but I can't just have a data frame of all the permutations to loop over because that would cause the exact same size and speed issue. Long story short: I need to generate all possible permutations of 1's and 0's for n bernoulli trials, but I need to do this one at a time such that all of them are generated and none are generated more than once for arbitrary n. For n = 3, 2^3 = 8, I would first generate 000 calculate if my test statistic was greater (1 or 0) then generate 001 calculate again, then generate 010 calculate, then generate 100 calculate, then generate 011 etc until 111 I'm fine with this being a loop over 2^n, that outputs the permutation at each step of the loop but doesn't save them all somewhere. Also I don't care what order they are generated in, the above is just how I would list these out if I was doing it by hand. In addition if there is anyway to speed up the previous code that would also be helpful.
A good solution for your problem is iterators. There is a package called arrangements that is able to generate permutations in an iterative fashion. Observe: library(arrangements) # initialize iterator iperm <- ipermutations(0:1, 3, replace = T) for (i in 1:(2^3)) { print(iperm$getnext()) } [1] 0 0 0 [1] 0 0 1 . . . [1] 1 1 1 It is written in C and is very efficient. You can also generate m permutations at a time like so: iperm$getnext(m) This allows for better performance because the next permutations are being generated by a for loop in C as opposed to a for loop in R. If you really need to ramp up performance you can you the parallel package. iperm <- ipermutations(0:1, 40, replace = T) parallel::mclapply(1:100, function(x) { myPerms <- iperm$getnext(10000) # do something }, mc.cores = parallel::detectCores() - 1) Note: All code is untested.
Print all values greater than some value without using booleans in R?
anyone got any idea how to print element greater than some value from a set without using booleans? E.g., suppose I have the set x, which includes the elements (1, 4, 6, 3, 5, 2, 9). Obviously, we can print all the values of x greater than 5 using the following code: x[x>5] But this way of coding uses booleans (it uses TRUE, FALSE etc.) But is there any way to do this using solely integers? I was thinking about some sort of loop that would start contain the number of elements, and then do x[c(variable)] but I don't know really. Please help?
Forming a Wright-Fisher loop with "sample()"
I am trying to create a simple loop to generate a Wright-Fisher simulation of genetic drift with the sample() function (I'm actually not dead-set on using this function, but, in my naivety, it seems like the right way to go). I know that sample() randomly selects values from a vector based on certain probabilities. My goal is to create a system that will keep running making random selections from successive sets. For example, if it takes some original set of values and samples a second set, I'd like the loop to take another random sample from the second set (using the probabilities that were defined earlier). I'd like to just learn how to do this in a very general way. Therefore, the specific probabilities and elements are arbitrary at this point. The only things that matter are (1) that every element can be repeated and (2) the size of the set must stay constant across generations, per Wright-Fisher. For an example, I've been playing with the following: V <- c(1,1,2,2,2,2) sample(V, size=6, replace=TRUE, prob=c(1,1,1,1,1,1)) Regrettably, my issue is that I don't have any code to share yet precisely because I'm not sure of how to start writing this kind of loop. I know that for() loops are used to repeat a function multiple times, so my guess is to start there. However, from what I've researched about these, it seems that you have to start with a variable (typically i). I don't have any variables in this sampling that seem explicitly obvious; which isn't to say one couldn't be made up.
If you wanted to repeatedly sample from a population with replacement for a total of iter iterations, you could use a for loop: set.seed(144) # For reproducibility population <- init.population for (iter in seq_len(iter)) { population <- sample(population, replace=TRUE) } population # [1] 1 1 1 1 1 1 Data: init.population <- c(1, 1, 2, 2, 2, 2) iter <- 100